/*
 * Created by IntelliJ IDEA.
 * User: Dominik
 * Date: 11.05.2004
 * Time: 12:57:20
 */

/**
 * A detector that can detect rays.
 */
public class Detector {
    /**
     * Constructs a detector that is a line in the plane.
     * @param a  start point of the detector
     * @param b  end point of the detector
     */
    public Detector(Vector2D a, Vector2D b) {
        this.a = a;
        this.b = b;
    }

    /**
     * Returns the start point.
     * @return Vector2D  start point
     */
    public Vector2D a() {return a;}

    /**
     * Returns the end point.
     * @return Vector2D  end point
     */
    public Vector2D b() {return b;}

    /**
     * Returns the point of intersection between the detector and a given line.
     * @param start  start point of the given line
     * @param end  end point of the given line
     * @return Vector2D  the point of intersection or null if there is no intersection
     */
    public Vector2D getIntersection(Vector2D start, Vector2D end) {
        return Vector2D.getIntersectionOfTwoLines(start, end, a, b);
    }

    private Vector2D a, b;
}
