/*
 * Created by IntelliJ IDEA.
 * User: Dominik
 * Date: 10.05.2004
 * Time: 14:53:01
 */

import javax.swing.*;
import java.awt.*;

/**
 * A canvas that is used to visualize Rainbow Sort.
 */
public class MyCanvas extends JPanel {
    /**
     * The constructor.
     * @param w  the width in pixels
     * @param h  the height in pixels
     * @param x  the maximum x coordinate that can be displayed
     * @param y  the maximum y coordinate that can be displayed
     * @param r  an object that represents all rays
     * @param s  an object that represents the scene (prism, detector)
     */
    public MyCanvas(int w, int h, double x, double y, Rays r, Scene s) {
        width = w;
        height = h;
        maxCoordX = x;
        maxCoordY = y;
        rays = r;
        scene = s;

        setPreferredSize(new Dimension(width, height));
        setBackground(Color.BLACK);
    }

    /**
     * Paints the canvas.
     */
    public void paint(Graphics g) {
        super.paint(g);
        scene.draw(this, g); // draw the scene (prism, detector)
        rays.draw(this, g); // draw the rays
    }

    /**
     * Returns the x coordinate in pixels of the given world coordinates.
     */
    public int pX(Vector2D coord) {
        return (int)(coord.x() / maxCoordX * width);
    }

    /**
     * Returns the y coordinate in pixels of the given world coordinates.
     */
    public int pY(Vector2D coord) {
        return (int)(coord.y() / maxCoordY * height);
    }

    private int width;
    private int height;
    private double maxCoordX;
    private double maxCoordY;

    private Rays rays;
    private Scene scene;
}
