/*
 * Created by IntelliJ IDEA.
 * User: Dominik
 * Date: 06.03.2004
 * Time: 14:01:05
 */
import javax.swing.table.AbstractTableModel;

/**
 * A simple table model used for the input/output table.
 */
public class SimpleTableModel extends AbstractTableModel {
    /**
     * Constructs a new SimpleTableModel containing the given data.
     * The column names are numbered consecutively from 0 to n-1.
     */
    public SimpleTableModel(Object[][] data) {
        this.data = data;
        columnNames = new String[data[0].length];
        for (int i = 0; i < columnNames.length; i++) {
            columnNames[i] = "" + i;
        }
    }

    public int getColumnCount() {
        return columnNames.length;
    }

    public int getRowCount() {
        return data.length;
    }

    public String getColumnName(int col) {
        return columnNames[col];
    }

    public Object getValueAt(int row, int col) {
        return data[row][col];
    }

    public Class getColumnClass(int columnIndex) {
        return String.class;
    }

    public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
        data[rowIndex][columnIndex] = aValue;
    }

    private String[] columnNames;
    private Object[][] data;
}
